using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.Sql;
using System.Data.SqlClient;
namespace DataGridDemo
{
    public partial class _Default : System.Web.UI.Page
    {
        string conString = @"Data Source=.\SQLEXPRESS;AttachDbFilename=""|DataDirectory|\Employee.mdf"";Integrated Security=True;User Instance=True";
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                BindTable();
            }
        }

        private void BindTable()
        {
            grdEmp.DataSource = GetTableFromDataBase();
            grdEmp.DataBind();
        }

        private DataTable GetTableFromDataBase()
        {
            SqlConnection con = null;
            SqlDataAdapter adp = null;
            DataTable dt = new DataTable();
            try
            {
                con = new SqlConnection(conString);
                con.Open();
                adp = new SqlDataAdapter("Select * from Employee",con);
                adp.Fill(dt);
                return dt;
            }
            catch (CustomException ex)
            {
                ex.logException();
            }finally{
                con.Close();
            }
            return null;
        }
        
        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            SqlConnection con = null;
            SqlCommand cmd = null;
            try
            {
                con = new SqlConnection(conString);
                con.Open();
                cmd = new SqlCommand("AddEmployee", con);
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.AddWithValue("@FName", txtFName.Text);
                cmd.Parameters.AddWithValue("@LName", txtLName.Text);
                cmd.Parameters.AddWithValue("@Email", txtEmail.Text);
                cmd.ExecuteNonQuery();
                showConfirmationMessage();
                GetTableFromDataBase();
            }
            catch (CustomException ex)
            {
                ex.logException();
            }finally{
                con.Close();
            }
        }

        private void showConfirmationMessage()
        {
            ClientScriptManager csMngr = Page.ClientScript;
            csMngr.RegisterStartupScript(Page.GetType(), "Success", "alert('Record Added succesfully');", true);
        }

        protected void grdEmp_Paging(object source,DataGridPageChangedEventArgs p)
        {
            grdEmp.CurrentPageIndex = p.NewPageIndex;
            BindTable();
        }

        protected void grdEmp_Sort(object source, DataGridSortCommandEventArgs e)
        {
            DataTable dt = GetTableFromDataBase();
            DataView dv = dt.DefaultView;
            string dir = string.Empty;

            if (e.SortExpression.Length > 0)
            {
                if (Session["OldSortDir"] == null)
                {                    
                    Session["OldSortDir"] = e.SortExpression;
                }
                else
                {
                    string oldSortExp = Session["OldSortDir"].ToString();
                    if (oldSortExp == "asc")
                    {
                        dir = "desc";
                        Session["OldSortDir"] = "desc";
                    }
                    else
                    {
                        dir = "asc";
                        Session["OldSortDir"] = "asc";
                    }
                }

                dv.Sort = e.SortExpression+"  "+dir;
            }
            grdEmp.DataSource = dv;
            grdEmp.DataBind();
        }
    }
}
